# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ContainerdConfigurationInitArgs', 'ContainerdConfiguration']

@pulumi.input_type
class ContainerdConfigurationInitArgs:
    def __init__(__self__, *,
                 cri: Optional['ContainerdCriPluginConfigurationArgs'] = None):
        """
        The set of arguments for constructing a ContainerdConfiguration resource.
        :param 'ContainerdCriPluginConfigurationArgs' cri: The cri configuration.
        """
        if cri is not None:
            pulumi.set(__self__, "cri", cri)

    @property
    @pulumi.getter
    def cri(self) -> Optional['ContainerdCriPluginConfigurationArgs']:
        """
        The cri configuration.
        """
        return pulumi.get(self, "cri")

    @cri.setter
    def cri(self, value: Optional['ContainerdCriPluginConfigurationArgs']):
        pulumi.set(self, "cri", value)


class ContainerdConfiguration(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cri: Optional[pulumi.InputType['ContainerdCriPluginConfigurationArgs']] = None,
                 __props__=None):
        """
        Get the containerd configuration.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.InputType['ContainerdCriPluginConfigurationArgs'] cri: The cri configuration.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ContainerdConfigurationInitArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Get the containerd configuration.

        :param str resource_name: The name of the resource.
        :param ContainerdConfigurationInitArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ContainerdConfigurationInitArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cri: Optional[pulumi.InputType['ContainerdCriPluginConfigurationArgs']] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ContainerdConfigurationInitArgs.__new__(ContainerdConfigurationInitArgs)

            __props__.__dict__["cri"] = cri
            __props__.__dict__["result"] = None
            __props__.__dict__["toml"] = None
        super(ContainerdConfiguration, __self__).__init__(
            'kubernetes-the-hard-way:config:ContainerdConfiguration',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def result(self) -> pulumi.Output['outputs.ContainerdConfiguration']:
        return pulumi.get(self, "result")

    @property
    @pulumi.getter
    def toml(self) -> pulumi.Output[str]:
        """
        The toml representation of the configuration.
        """
        return pulumi.get(self, "toml")

