# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetCniBridgePluginConfigurationResult',
    'AwaitableGetCniBridgePluginConfigurationResult',
    'get_cni_bridge_plugin_configuration',
    'get_cni_bridge_plugin_configuration_output',
]

@pulumi.output_type
class GetCniBridgePluginConfigurationResult:
    """
    Get the `bridge` configuration.
    """
    def __init__(__self__, result=None):
        if result and not isinstance(result, dict):
            raise TypeError("Expected argument 'result' to be a dict")
        pulumi.set(__self__, "result", result)

    @property
    @pulumi.getter
    def result(self) -> 'outputs.CniBridgePluginConfiguration':
        return pulumi.get(self, "result")


class AwaitableGetCniBridgePluginConfigurationResult(GetCniBridgePluginConfigurationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCniBridgePluginConfigurationResult(
            result=self.result)


def get_cni_bridge_plugin_configuration(bridge: Optional[str] = None,
                                        cni_version: Optional[str] = None,
                                        ip_masq: Optional[bool] = None,
                                        ipam: Optional[pulumi.InputType['CniBridgeIpam']] = None,
                                        is_gateway: Optional[bool] = None,
                                        name: Optional[str] = None,
                                        subnet: Optional[str] = None,
                                        type: Optional[str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCniBridgePluginConfigurationResult:
    """
    Get the `bridge` configuration.


    :param str bridge: Bridge name.
    :param str cni_version: CNI version.
    :param bool ip_masq: IP masq.
    :param pulumi.InputType['CniBridgeIpam'] ipam: IPAM
    :param bool is_gateway: Is gateway.
    :param str name: CNI plugin name.
    :param str subnet: The subnet to use.
    :param str type: CNI plugin type.
    """
    __args__ = dict()
    __args__['bridge'] = bridge
    __args__['cniVersion'] = cni_version
    __args__['ipMasq'] = ip_masq
    __args__['ipam'] = ipam
    __args__['isGateway'] = is_gateway
    __args__['name'] = name
    __args__['subnet'] = subnet
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('kubernetes-the-hard-way:config:getCniBridgePluginConfiguration', __args__, opts=opts, typ=GetCniBridgePluginConfigurationResult).value

    return AwaitableGetCniBridgePluginConfigurationResult(
        result=pulumi.get(__ret__, 'result'))


@_utilities.lift_output_func(get_cni_bridge_plugin_configuration)
def get_cni_bridge_plugin_configuration_output(bridge: Optional[pulumi.Input[Optional[str]]] = None,
                                               cni_version: Optional[pulumi.Input[Optional[str]]] = None,
                                               ip_masq: Optional[pulumi.Input[Optional[bool]]] = None,
                                               ipam: Optional[pulumi.Input[Optional[pulumi.InputType['CniBridgeIpam']]]] = None,
                                               is_gateway: Optional[pulumi.Input[Optional[bool]]] = None,
                                               name: Optional[pulumi.Input[Optional[str]]] = None,
                                               subnet: Optional[pulumi.Input[str]] = None,
                                               type: Optional[pulumi.Input[Optional[str]]] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCniBridgePluginConfigurationResult]:
    """
    Get the `bridge` configuration.


    :param str bridge: Bridge name.
    :param str cni_version: CNI version.
    :param bool ip_masq: IP masq.
    :param pulumi.InputType['CniBridgeIpam'] ipam: IPAM
    :param bool is_gateway: Is gateway.
    :param str name: CNI plugin name.
    :param str subnet: The subnet to use.
    :param str type: CNI plugin type.
    """
    ...
