# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from .. import tools as _tools
from .file import File
import pulumi_command

__all__ = ['EtcdConfigurationArgs', 'EtcdConfiguration']

@pulumi.input_type
class EtcdConfigurationArgs:
    def __init__(__self__, *,
                 ca_pem: pulumi.Input[str],
                 cert_pem: pulumi.Input[str],
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 etcd_path: pulumi.Input[str],
                 internal_ip: pulumi.Input[str],
                 key_pem: pulumi.Input[str],
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a EtcdConfiguration resource.
        :param pulumi.Input[str] ca_pem: The PEM encoded certificate authority data.
        :param pulumi.Input[str] cert_pem: The PEM encoded certificate data.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] etcd_path: The path to the `etcd` binary.
        :param pulumi.Input[str] internal_ip: The IP used to serve client requests and communicate with etcd peers.
        :param pulumi.Input[str] key_pem: The PEM encoded key data.
        :param pulumi.Input[str] configuration_directory: The directory to store etcd configuration.
        :param pulumi.Input[str] data_directory: The directory etcd will store its data.
        """
        pulumi.set(__self__, "ca_pem", ca_pem)
        pulumi.set(__self__, "cert_pem", cert_pem)
        pulumi.set(__self__, "connection", connection)
        pulumi.set(__self__, "etcd_path", etcd_path)
        pulumi.set(__self__, "internal_ip", internal_ip)
        pulumi.set(__self__, "key_pem", key_pem)
        if configuration_directory is None:
            configuration_directory = '/etc/etcd'
        if configuration_directory is not None:
            pulumi.set(__self__, "configuration_directory", configuration_directory)
        if data_directory is None:
            data_directory = '/var/lib/etcd'
        if data_directory is not None:
            pulumi.set(__self__, "data_directory", data_directory)

    @property
    @pulumi.getter(name="caPem")
    def ca_pem(self) -> pulumi.Input[str]:
        """
        The PEM encoded certificate authority data.
        """
        return pulumi.get(self, "ca_pem")

    @ca_pem.setter
    def ca_pem(self, value: pulumi.Input[str]):
        pulumi.set(self, "ca_pem", value)

    @property
    @pulumi.getter(name="certPem")
    def cert_pem(self) -> pulumi.Input[str]:
        """
        The PEM encoded certificate data.
        """
        return pulumi.get(self, "cert_pem")

    @cert_pem.setter
    def cert_pem(self, value: pulumi.Input[str]):
        pulumi.set(self, "cert_pem", value)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter(name="etcdPath")
    def etcd_path(self) -> pulumi.Input[str]:
        """
        The path to the `etcd` binary.
        """
        return pulumi.get(self, "etcd_path")

    @etcd_path.setter
    def etcd_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "etcd_path", value)

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Input[str]:
        """
        The IP used to serve client requests and communicate with etcd peers.
        """
        return pulumi.get(self, "internal_ip")

    @internal_ip.setter
    def internal_ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "internal_ip", value)

    @property
    @pulumi.getter(name="keyPem")
    def key_pem(self) -> pulumi.Input[str]:
        """
        The PEM encoded key data.
        """
        return pulumi.get(self, "key_pem")

    @key_pem.setter
    def key_pem(self, value: pulumi.Input[str]):
        pulumi.set(self, "key_pem", value)

    @property
    @pulumi.getter(name="configurationDirectory")
    def configuration_directory(self) -> Optional[pulumi.Input[str]]:
        """
        The directory to store etcd configuration.
        """
        return pulumi.get(self, "configuration_directory")

    @configuration_directory.setter
    def configuration_directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "configuration_directory", value)

    @property
    @pulumi.getter(name="dataDirectory")
    def data_directory(self) -> Optional[pulumi.Input[str]]:
        """
        The directory etcd will store its data.
        """
        return pulumi.get(self, "data_directory")

    @data_directory.setter
    def data_directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_directory", value)


class EtcdConfiguration(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ca_pem: Optional[pulumi.Input[str]] = None,
                 cert_pem: Optional[pulumi.Input[str]] = None,
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None,
                 etcd_path: Optional[pulumi.Input[str]] = None,
                 internal_ip: Optional[pulumi.Input[str]] = None,
                 key_pem: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configures etcd on a remote system.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ca_pem: The PEM encoded certificate authority data.
        :param pulumi.Input[str] cert_pem: The PEM encoded certificate data.
        :param pulumi.Input[str] configuration_directory: The directory to store etcd configuration.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] data_directory: The directory etcd will store its data.
        :param pulumi.Input[str] etcd_path: The path to the `etcd` binary.
        :param pulumi.Input[str] internal_ip: The IP used to serve client requests and communicate with etcd peers.
        :param pulumi.Input[str] key_pem: The PEM encoded key data.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: EtcdConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configures etcd on a remote system.

        :param str resource_name: The name of the resource.
        :param EtcdConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(EtcdConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ca_pem: Optional[pulumi.Input[str]] = None,
                 cert_pem: Optional[pulumi.Input[str]] = None,
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None,
                 etcd_path: Optional[pulumi.Input[str]] = None,
                 internal_ip: Optional[pulumi.Input[str]] = None,
                 key_pem: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = EtcdConfigurationArgs.__new__(EtcdConfigurationArgs)

            if ca_pem is None and not opts.urn:
                raise TypeError("Missing required property 'ca_pem'")
            __props__.__dict__["ca_pem"] = ca_pem
            if cert_pem is None and not opts.urn:
                raise TypeError("Missing required property 'cert_pem'")
            __props__.__dict__["cert_pem"] = cert_pem
            if configuration_directory is None:
                configuration_directory = '/etc/etcd'
            __props__.__dict__["configuration_directory"] = configuration_directory
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            if data_directory is None:
                data_directory = '/var/lib/etcd'
            __props__.__dict__["data_directory"] = data_directory
            if etcd_path is None and not opts.urn:
                raise TypeError("Missing required property 'etcd_path'")
            __props__.__dict__["etcd_path"] = etcd_path
            if internal_ip is None and not opts.urn:
                raise TypeError("Missing required property 'internal_ip'")
            __props__.__dict__["internal_ip"] = internal_ip
            if key_pem is None and not opts.urn:
                raise TypeError("Missing required property 'key_pem'")
            __props__.__dict__["key_pem"] = key_pem
            __props__.__dict__["ca_file"] = None
            __props__.__dict__["cert_file"] = None
            __props__.__dict__["configuration_chmod"] = None
            __props__.__dict__["configuration_mkdir"] = None
            __props__.__dict__["data_mkdir"] = None
            __props__.__dict__["key_file"] = None
            __props__.__dict__["value"] = None
        super(EtcdConfiguration, __self__).__init__(
            'kubernetes-the-hard-way:remote:EtcdConfiguration',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter(name="caFile")
    def ca_file(self) -> pulumi.Output['File']:
        """
        The remote certificate authority file.
        """
        return pulumi.get(self, "ca_file")

    @property
    @pulumi.getter(name="caPem")
    def ca_pem(self) -> pulumi.Output[str]:
        """
        The PEM encoded certificate authority data.
        """
        return pulumi.get(self, "ca_pem")

    @property
    @pulumi.getter(name="certFile")
    def cert_file(self) -> pulumi.Output['File']:
        """
        The remote certificate file.
        """
        return pulumi.get(self, "cert_file")

    @property
    @pulumi.getter(name="certPem")
    def cert_pem(self) -> pulumi.Output[str]:
        """
        The PEM encoded certificate data.
        """
        return pulumi.get(self, "cert_pem")

    @property
    @pulumi.getter(name="configurationChmod")
    def configuration_chmod(self) -> pulumi.Output[Optional['_tools.Chmod']]:
        """
        The configuration chmod operation.
        """
        return pulumi.get(self, "configuration_chmod")

    @property
    @pulumi.getter(name="configurationDirectory")
    def configuration_directory(self) -> pulumi.Output[str]:
        """
        The directory to store etcd configuration.
        """
        return pulumi.get(self, "configuration_directory")

    @property
    @pulumi.getter(name="configurationMkdir")
    def configuration_mkdir(self) -> pulumi.Output['_tools.Mkdir']:
        """
        The configuration mkdir operation.
        """
        return pulumi.get(self, "configuration_mkdir")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter(name="dataDirectory")
    def data_directory(self) -> pulumi.Output[str]:
        """
        The directory etcd will store its data.
        """
        return pulumi.get(self, "data_directory")

    @property
    @pulumi.getter(name="dataMkdir")
    def data_mkdir(self) -> pulumi.Output['_tools.Mkdir']:
        """
        The data mkdir operation.
        """
        return pulumi.get(self, "data_mkdir")

    @property
    @pulumi.getter(name="etcdPath")
    def etcd_path(self) -> pulumi.Output[str]:
        """
        The path to the `etcd` binary.
        """
        return pulumi.get(self, "etcd_path")

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Output[str]:
        """
        The IP used to serve client requests and communicate with etcd peers.
        """
        return pulumi.get(self, "internal_ip")

    @property
    @pulumi.getter(name="keyFile")
    def key_file(self) -> pulumi.Output['File']:
        """
        The remote key file.
        """
        return pulumi.get(self, "key_file")

    @property
    @pulumi.getter(name="keyPem")
    def key_pem(self) -> pulumi.Output[str]:
        """
        The PEM encoded key data.
        """
        return pulumi.get(self, "key_pem")

    @property
    @pulumi.getter
    def value(self) -> pulumi.Output['outputs.EtcdConfigurationProps']:
        """
        A bag of properties to be consumed by other resources.
        """
        return pulumi.get(self, "value")

