# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from .. import tls as _tls
from ._enums import *
from .etcd_configuration import EtcdConfiguration
from .etcd_install import EtcdInstall
from .start_etcd import StartEtcd
from .systemd_service import SystemdService
import pulumi_command

__all__ = ['ProvisionEtcdArgs', 'ProvisionEtcd']

@pulumi.input_type
class ProvisionEtcdArgs:
    def __init__(__self__, *,
                 bundle: pulumi.Input['_tls.BundleArgs'],
                 connection: pulumi.Input['pulumi_command.remote.ConnectionArgs'],
                 internal_ip: pulumi.Input[str],
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 binary_directory: Optional[pulumi.Input[str]] = None,
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ProvisionEtcd resource.
        :param pulumi.Input['_tls.BundleArgs'] bundle: The TLS bundle.
        :param pulumi.Input['pulumi_command.remote.ConnectionArgs'] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] internal_ip: The internal IP of the etcd node
        :param pulumi.Input['Architecture'] architecture: TODO
        :param pulumi.Input[str] binary_directory: TODO
        :param pulumi.Input[str] configuration_directory: The directory to use for etcd configuration.
        :param pulumi.Input[str] data_directory: The directory to use for etcd data.
        :param pulumi.Input[str] version: The version to install.
        """
        pulumi.set(__self__, "bundle", bundle)
        pulumi.set(__self__, "connection", connection)
        pulumi.set(__self__, "internal_ip", internal_ip)
        if architecture is not None:
            pulumi.set(__self__, "architecture", architecture)
        if binary_directory is not None:
            pulumi.set(__self__, "binary_directory", binary_directory)
        if configuration_directory is not None:
            pulumi.set(__self__, "configuration_directory", configuration_directory)
        if data_directory is not None:
            pulumi.set(__self__, "data_directory", data_directory)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def bundle(self) -> pulumi.Input['_tls.BundleArgs']:
        """
        The TLS bundle.
        """
        return pulumi.get(self, "bundle")

    @bundle.setter
    def bundle(self, value: pulumi.Input['_tls.BundleArgs']):
        pulumi.set(self, "bundle", value)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['pulumi_command.remote.ConnectionArgs']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['pulumi_command.remote.ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Input[str]:
        """
        The internal IP of the etcd node
        """
        return pulumi.get(self, "internal_ip")

    @internal_ip.setter
    def internal_ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "internal_ip", value)

    @property
    @pulumi.getter
    def architecture(self) -> Optional[pulumi.Input['Architecture']]:
        """
        TODO
        """
        return pulumi.get(self, "architecture")

    @architecture.setter
    def architecture(self, value: Optional[pulumi.Input['Architecture']]):
        pulumi.set(self, "architecture", value)

    @property
    @pulumi.getter(name="binaryDirectory")
    def binary_directory(self) -> Optional[pulumi.Input[str]]:
        """
        TODO
        """
        return pulumi.get(self, "binary_directory")

    @binary_directory.setter
    def binary_directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "binary_directory", value)

    @property
    @pulumi.getter(name="configurationDirectory")
    def configuration_directory(self) -> Optional[pulumi.Input[str]]:
        """
        The directory to use for etcd configuration.
        """
        return pulumi.get(self, "configuration_directory")

    @configuration_directory.setter
    def configuration_directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "configuration_directory", value)

    @property
    @pulumi.getter(name="dataDirectory")
    def data_directory(self) -> Optional[pulumi.Input[str]]:
        """
        The directory to use for etcd data.
        """
        return pulumi.get(self, "data_directory")

    @data_directory.setter
    def data_directory(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_directory", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        The version to install.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)


class ProvisionEtcd(pulumi.ComponentResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 binary_directory: Optional[pulumi.Input[str]] = None,
                 bundle: Optional[pulumi.Input[pulumi.InputType['_tls.BundleArgs']]] = None,
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None,
                 internal_ip: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Starts etcd on a remote system.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input['Architecture'] architecture: TODO
        :param pulumi.Input[str] binary_directory: TODO
        :param pulumi.Input[pulumi.InputType['_tls.BundleArgs']] bundle: The TLS bundle.
        :param pulumi.Input[str] configuration_directory: The directory to use for etcd configuration.
        :param pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']] connection: The parameters with which to connect to the remote host.
        :param pulumi.Input[str] data_directory: The directory to use for etcd data.
        :param pulumi.Input[str] internal_ip: The internal IP of the etcd node
        :param pulumi.Input[str] version: The version to install.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProvisionEtcdArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Starts etcd on a remote system.

        :param str resource_name: The name of the resource.
        :param ProvisionEtcdArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProvisionEtcdArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 architecture: Optional[pulumi.Input['Architecture']] = None,
                 binary_directory: Optional[pulumi.Input[str]] = None,
                 bundle: Optional[pulumi.Input[pulumi.InputType['_tls.BundleArgs']]] = None,
                 configuration_directory: Optional[pulumi.Input[str]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['pulumi_command.remote.ConnectionArgs']]] = None,
                 data_directory: Optional[pulumi.Input[str]] = None,
                 internal_ip: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is not None:
            raise ValueError('ComponentResource classes do not support opts.id')
        else:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProvisionEtcdArgs.__new__(ProvisionEtcdArgs)

            __props__.__dict__["architecture"] = architecture
            __props__.__dict__["binary_directory"] = binary_directory
            if bundle is None and not opts.urn:
                raise TypeError("Missing required property 'bundle'")
            __props__.__dict__["bundle"] = bundle
            __props__.__dict__["configuration_directory"] = configuration_directory
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["data_directory"] = data_directory
            if internal_ip is None and not opts.urn:
                raise TypeError("Missing required property 'internal_ip'")
            __props__.__dict__["internal_ip"] = internal_ip
            __props__.__dict__["version"] = version
            __props__.__dict__["configuration"] = None
            __props__.__dict__["install"] = None
            __props__.__dict__["service"] = None
            __props__.__dict__["start"] = None
        super(ProvisionEtcd, __self__).__init__(
            'kubernetes-the-hard-way:remote:ProvisionEtcd',
            resource_name,
            __props__,
            opts,
            remote=True)

    @property
    @pulumi.getter
    def architecture(self) -> pulumi.Output[Optional['Architecture']]:
        """
        TODO
        """
        return pulumi.get(self, "architecture")

    @property
    @pulumi.getter(name="binaryDirectory")
    def binary_directory(self) -> pulumi.Output[Optional[str]]:
        """
        TODO
        """
        return pulumi.get(self, "binary_directory")

    @property
    @pulumi.getter
    def bundle(self) -> pulumi.Output['_tls.outputs.Bundle']:
        """
        The TLS bundle.
        """
        return pulumi.get(self, "bundle")

    @property
    @pulumi.getter
    def configuration(self) -> pulumi.Output['EtcdConfiguration']:
        """
        Etcd configuration.
        """
        return pulumi.get(self, "configuration")

    @property
    @pulumi.getter(name="configurationDirectory")
    def configuration_directory(self) -> pulumi.Output[Optional[str]]:
        """
        The directory to use for etcd configuration.
        """
        return pulumi.get(self, "configuration_directory")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['pulumi_command.remote.outputs.Connection']:
        """
        The parameters with which to connect to the remote host.
        """
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter(name="dataDirectory")
    def data_directory(self) -> pulumi.Output[Optional[str]]:
        """
        The directory to use for etcd data.
        """
        return pulumi.get(self, "data_directory")

    @property
    @pulumi.getter
    def install(self) -> pulumi.Output['EtcdInstall']:
        """
        Install etcd.
        """
        return pulumi.get(self, "install")

    @property
    @pulumi.getter(name="internalIp")
    def internal_ip(self) -> pulumi.Output[str]:
        """
        The internal IP of the etcd node
        """
        return pulumi.get(self, "internal_ip")

    @property
    @pulumi.getter
    def service(self) -> pulumi.Output['SystemdService']:
        """
        Systemd service.
        """
        return pulumi.get(self, "service")

    @property
    @pulumi.getter
    def start(self) -> pulumi.Output['StartEtcd']:
        """
        Start etcd
        """
        return pulumi.get(self, "start")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[Optional[str]]:
        """
        The version to install.
        """
        return pulumi.get(self, "version")

